/* VIPPR config file grammar 
 * $Id: vippr_grammar.y,v 1.3 2001/06/12 14:25:51 fx Exp fx $
 */
%{
    #include "vippr.h"

    int	current_router=0;
%}

// %expect 1

%union {
	int	i_val;
	char	p_str[4096];
	char	ip_addr[16];
	char	mac_addr[13];
}

%token <i_val> PINT
%token <ip_addr> IPADDR
%token <mac_addr> MACADDR
%token <p_str> IDENT
%token <p_str> ASTRING

%token VIP
%token ROUTER
%token VIP_STEALTH
%token VIP_GRE
%token VIP_VLAN8021Q


%%	/* rules */

input:	/* empty */
	| input vipconfig
	;


vipconfig:	config_stealth ';'
		| config_gre ';'
		| config_gre_key ';'
		| router ';'
		;
		

config_stealth: VIP VIP_STEALTH '{' IPADDR '/' IPADDR ',' MACADDR ',' IDENT ',' PINT '}' { 
			/* ip, mask, MAC, router, ifname */
			vip_add_stealth($4,$6,$8,$12,$10);
		}
		;

config_gre:	VIP VIP_GRE '{' IPADDR '/' IPADDR ',' MACADDR 
			',' IDENT ',' PINT '<' IPADDR ',' IPADDR '>' '}' {
			
			/* ip, mask, MAC, router, ifname, t-source , t-dest */
			vip_add_gre($4, $6, $8, $12, $10, $14, $16, 0, 0);
		}
		;

config_gre_key:	VIP VIP_GRE '{' IPADDR '/' IPADDR ',' MACADDR 
			',' IDENT ',' PINT '<' IPADDR ',' IPADDR ',' 
			PINT '>' '}' {
			
			/* ip, mask, MAC, router, ifname, t-source , t-dest */
			vip_add_gre($4, $6, $8, $12, $10, $14, $16, 1, $18);
		}
		;

router:		ROUTER PINT {
			/* if the router already exists, it just
			 * returns ... */
			router_add($2);
			current_router=$2;
		} '{' rentry '}' {
			current_router=0;
		}
		;

rentry:		/* empty */
		| rentry routeline
		;

routeline:	IPADDR '/' IPADDR IPADDR ';' {
			router_add_route(current_router,$1,$3,$4);
		}
		

%%
